package main

import (
	"fmt"

	"github.com/urfave/cli"

	rpcx "gitlab.33.cn/link33/sidecar/hub/client"
	"gitlab.33.cn/link33/sidecar/model/constant"
)

var governanceCMD = cli.Command{
	Name:  "proposals",
	Usage: "proposals manage command",
	Subcommands: cli.Commands{
		cli.Command{
			Name:  "withdraw",
			Usage: "withdraw a proposal",
			Flags: []cli.Flag{
				adminKeyPathFlag,
				cli.StringFlag{
					Name:     "id",
					Usage:    "proposal id",
					Required: true,
				},
			},
			Action: withdraw,
		},
	},
}

// TODO
func withdraw(ctx *cli.Context) error {
	chainAdminKeyPath := ctx.String("admin-key")
	id := ctx.String("id")

	client, _, err := initClientWithKeyPath(ctx, chainAdminKeyPath)
	if err != nil {
		return fmt.Errorf("load client: %w", err)
	}

	// TODO modify hub client
	receipt, err := client.InvokeBVMContract(
		constant.GovernanceContractAddr.Address(),
		"WithdrawProposal", nil, rpcx.String(id),
	)
	if err != nil {
		return fmt.Errorf("invoke bvm contract: %w", err)
	}

	if !receipt.IsSuccess() {
		return fmt.Errorf("invoke withdraw proposal: %s", receipt.Ret)
	}

	return nil
}
