package checker

import (
	"fmt"
	"sync"

	"gitlab.33.cn/link33/sidecar/internal/rulemgr"
	"gitlab.33.cn/link33/sidecar/model/pb"
)

type MockChecker struct{}

func (ck *MockChecker) Check(ibtp *pb.IBTP) error {
	return nil
}

type checker struct {
	ruleMgr       *rulemgr.RuleMgr
	appchainCache sync.Map
}

type appchainRule struct {
	codeAddress string
}

func NewChecker(ruleMgr *rulemgr.RuleMgr) Checker {
	return &checker{
		ruleMgr: ruleMgr,
	}
}

func (c *checker) Check(ibtp *pb.IBTP) error {
	// todo check err
	// chainID := ibtp.From
	var validatorAddr string
	var trustRoot string
	// todo
	ok, err := c.ruleMgr.Validate(validatorAddr, ibtp.From, ibtp.Proof, ibtp.Payload, trustRoot)
	if err != nil {
		return err
	}

	if !ok {
		return fmt.Errorf("rule check failed")
	}

	return nil
}
